#include "DirectXLib.h"
#include "Window.h"


// EChEvV[W[
static LRESULT CALLBACK WndProc(HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
	switch( uiMsg )
	{
	case WM_CLOSE:		// ۂWindowj
		DestroyWindow(hWnd);
		return 0;
	case WM_DESTROY:	// vȌIʒm
		PostQuitMessage(0);
		return 0L;
	}
	// ̃EBhEvV[WĂяo
	return DefWindowProc(hWnd, uiMsg, wParam, lParam);
}

// RXgN^
SimpleWindow::SimpleWindow(void)
	: m_hWnd(nullptr)
	, m_isQuitMessage(false)
	, m_width(0)
	, m_height(0)
{
}

// fXgN^
SimpleWindow::~SimpleWindow(void)
{
}

// VvȃEBhE̍쐬
bool SimpleWindow::Create(const char* pName, int x, int y, int width, int height)
{
	WNDCLASSEX wcex;
	// EChE̐ݒ
	wcex.cbSize			= sizeof(WNDCLASSEX);
	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= GetModuleHandle(nullptr);
	wcex.hCursor		= LoadCursor(nullptr, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
	wcex.lpszMenuName	= nullptr;
	wcex.lpszClassName	= pName;
	wcex.hIcon			= LoadIcon(nullptr, IDC_ARROW);
	wcex.hIconSm		= LoadIcon(nullptr, IDI_APPLICATION);
	RegisterClassEx(&wcex);

	DWORD dwStyle = WS_OVERLAPPEDWINDOW;

	RECT Rect;
	Rect.left	= 0;
	Rect.top	= 0; 
	Rect.right	= width;
	Rect.bottom	= height;
	// EBhẼX^Cɍ킹K؂ȃTCY擾
	AdjustWindowRect(&Rect, dwStyle, false);

	width = Rect.right - Rect.left;
	height = Rect.bottom - Rect.top;

	// EChE̐
	m_hWnd = CreateWindow(wcex.lpszClassName,
		pName,
		dwStyle,
		x,
		y,
		width,
		height,
		nullptr,
		nullptr,
		GetModuleHandle(nullptr),
		nullptr);
	if (m_hWnd == nullptr)
	{
		return false;
	}

	m_width = width;
	m_height = height;
	// EChE̕\
	ShowWindow(m_hWnd, SW_SHOW);
	UpdateWindow(m_hWnd);

	return true;
}

// bZ[W̍XV
bool SimpleWindow::UpdateMessage(void)
{
	MSG msg;
	// bZ[W݂邩mF
	if (PeekMessage(&msg, nullptr, 0, 0, PM_REMOVE))
	{
		// IʒmĂꍇ͔
		if (msg.message == WM_QUIT)
		{
			m_isQuitMessage = true;
		}
		else
		{
			// bZ[WEChEvV[Wɓ]
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		return true;
	}
	return false;
}
